ghc-7.0.3: The GHC API

RegAlloc.Linear.StackMap

Description

The assignment of virtual registers to stack slots

Synopsis

- type StackSlot = Int
- data StackMap = StackMap {
  - stackMapFreeSlots :: [StackSlot]
  - stackMapAssignment :: UniqFM StackSlot
  }
- emptyStackMap :: StackMap
- getStackSlotFor :: StackMap -> Unique -> (StackMap, Int)

# Documentation

type StackSlot = Int

Identifier for a stack slot.

data StackMap

Constructors

StackMap |

Fields

stackMapFreeSlots :: [StackSlot]

  The slots that are still available to be allocated.

stackMapAssignment :: UniqFM StackSlot

  Assignment of vregs to stack slots.

emptyStackMap :: StackMap

An empty stack map, with all slots available.

getStackSlotFor :: StackMap -> Unique -> (StackMap, Int)

If this vreg unique already has a stack assignment then return the slot number, otherwise allocate a new slot, and update the map.